//  $HDR$
// **********************************************************************
//  Armin Diehl (diehl@nordrhein.de)
// **********************************************************************
//  $Log:  \\FS-AD\PRJ\GP-Version\Archives\i4l Monitor\I4lmon\Anruferliste.pas.z 
// 
//    Rev 1.1    25.12.2000 16:47:04  ad
//  Language support

// 
//    Rev 1.0    24.12.2000 15:22:31  ad
//  Initial Revision

// 
unit Anruferliste;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls,
  Lang, MsgConsts;

type
  TAnruferlisteForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    StringGrid1: TStringGrid;
    OkButton: TButton;
    ClearButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    LastNumber : STRING;
    LastTime   : TDateTime;
    { Private-Deklarationen }
  public
    PROCEDURE Add (PhoneNumber,Name : STRING);
    PROCEDURE SaveToFile;
    PROCEDURE RestoreFromFile;
    PROCEDURE LangChangedMsg (VAR Msg : TMessage); Message LangChangedMsgK;

    { Public-Deklarationen }
  end;

var
  AnruferlisteForm: TAnruferlisteForm;

implementation

{$R *.DFM}

procedure TAnruferlisteForm.FormCreate(Sender: TObject);
begin
  StringGrid1.RowCount := 1;
  RestoreFromFile;
  PostMessage(Handle,LangChangedMsgK,0,0);
end;


PROCEDURE TAnruferlisteForm.Add (PhoneNumber,Name : STRING);
BEGIN
  IF PhoneNumber = LastNumber THEN
    IF Frac (Now) > Frac (LastTime) THEN
      IF Frac (Now - LastTime) < (1.0 / 1440.0) THEN EXIT;
  LastNumber := PhoneNumber;
  LastTime := Now;
  StringGrid1.RowCount := StringGrid1.RowCount + 1;
  StringGrid1.FixedRows := 1;
  StringGrid1.Cells[0,StringGrid1.RowCount-1] := FormatDateTime (LongDateFormat,Date);
  StringGrid1.Cells[1,StringGrid1.RowCount-1] := FormatDateTime (LongTimeFormat,Time);
  StringGrid1.Cells[2,StringGrid1.RowCount-1] := PhoneNumber;
  StringGrid1.Cells[3,StringGrid1.RowCount-1] := Name;
END;

procedure TAnruferlisteForm.OkButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TAnruferlisteForm.ClearButtonClick(Sender: TObject);
begin
  StringGrid1.RowCount := 1;
end;

PROCEDURE TAnruferlisteForm.SaveToFile;
VAR FN : STRING[255];
    I  : INTEGER;
    T  : System.TEXT;
BEGIN
  TRY
    FN := Application.ExeName;
    BYTE (FN[0]) := Pos ('.',FN);
    FN := FN + 'ANR';
    IF StringGrid1.RowCount <= 1 THEN
    BEGIN
      SysUtils.DeleteFile (FN);
    END ELSE
    BEGIN
      System.Assign (T,FN); ReWrite (T);
      TRY
        WriteLn (T,'Date'#9'Time'#9'Phone'#9'Name');
        FOR I := 1 TO StringGrid1.RowCount-1 DO
        BEGIN
          WriteLn (T,StringGrid1.Cells[0,I],#9,
                     StringGrid1.Cells[1,I],#9,
                     StringGrid1.Cells[2,I],#9,
                     StringGrid1.Cells[3,I]);
        END;
      FINALLY
        System.Close (T);
      END;
    END;
  EXCEPT
  END;
END;


PROCEDURE TAnruferlisteForm.RestoreFromFile;
VAR FN : STRING[255];
    I,P: INTEGER;
    T  : System.TEXT;
    S  : STRING;
BEGIN
  TRY
    FN := Application.ExeName;
    BYTE (FN[0]) := Pos ('.',FN);
    FN := FN + 'ANR';
    System.Assign (T,FN);
    Reset (T);
    IF IOResult <> 0 THEN EXIT;
    TRY
      ReadLn (T, S);
      WHILE NOT EOF (T) DO
      BEGIN
        ReadLn (T, S);
        IF S <> '' THEN
        BEGIN
          StringGrid1.RowCount := StringGrid1.RowCount + 1;
          StringGrid1.FixedRows := 1;
          FOR I := 0 TO 3 DO
          BEGIN
            P := Pos (#9,S);
            IF P > 0 THEN
            BEGIN
              StringGrid1.Cells[I,StringGrid1.RowCount-1] := Copy (S,1,P-1);
              Delete (S,1,P);
            END ELSE
            BEGIN
              StringGrid1.Cells[I,StringGrid1.RowCount-1] := S;
              S := '';
            END;
          END;
        END;
      END;
    FINALLY
      System.Close (T);
    END;
  EXCEPT
  END;
END;

procedure TAnruferlisteForm.FormDestroy(Sender: TObject);
begin
  SaveToFile;
end;

PROCEDURE TAnruferlisteForm.LangChangedMsg (VAR Msg : TMessage);
BEGIN
  Caption := GetMsg (M_CL_CaptionK);
  StringGrid1.Cells[0,0] := GetMsg (M_CL_DateK);
  StringGrid1.Cells[1,0] := GetMsg (M_CL_TimeK);
  StringGrid1.Cells[2,0] := GetMsg (M_CL_NumberK);
  StringGrid1.Cells[3,0] := GetMsg (M_CL_NameK);
  OkButton.Caption := GetMsg (M_ButtonOkK);
  ClearButton.Caption := GetMsg (M_ButtonClearAllK);
END;

end.
