//  $HDR$
// **********************************************************************
//  Armin Diehl (diehl@nordrhein.de)
// **********************************************************************
//  $Log:  \\FS-AD\PRJ\GP-Version\Archives\i4l Monitor\I4lmon\ConnectionList.pas.z 
// 
//    Rev 1.1    25.12.2000 16:37:41  ad

// 
//    Rev 1.0    24.12.2000 15:22:31  ad
//  Initial Revision

// 
unit ConnectionList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, ExtCtrls, Isdn4Linux,
  Lang, MsgConsts;

type
  TConnectionListForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    OkButton: TButton;
    ClearButton: TButton;
    StringGrid1: TStringGrid;
    procedure ClearButtonClick(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    PROCEDURE Add (VAR S : TIsdnStatus);
    PROCEDURE SaveToFile;
    PROCEDURE RestoreFromFile;
    PROCEDURE LangChangedMsg (VAR Msg : TMessage); Message LangChangedMsgK;
  end;

var
  ConnectionListForm: TConnectionListForm;

implementation

{$R *.DFM}

procedure TConnectionListForm.ClearButtonClick(Sender: TObject);
begin
  StringGrid1.RowCount := 1;
end;

procedure TConnectionListForm.OkButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TConnectionListForm.FormCreate(Sender: TObject);
begin
  StringGrid1.RowCount := 1;
  StringGrid1.Cells[0,0] := 'Datum';
  StringGrid1.Cells[1,0] := 'Zeit';
  StringGrid1.Cells[2,0] := 'Dauer';
  StringGrid1.Cells[3,0] := 'Rufnummer';
  StringGrid1.Cells[4,0] := 'Name';
  StringGrid1.Cells[5,0] := 'Dienst';
  StringGrid1.Cells[6,0] := 'Typ';
  RestoreFromFile;
  PostMessage(Handle,LangChangedMsgK,0,0);
end;

PROCEDURE TConnectionListForm.Add (VAR S : TIsdnStatus);
VAR I : INTEGER;
BEGIN
  I := StringGrid1.RowCount;
  StringGrid1.RowCount := I+1;
  StringGrid1.FixedRows := 1;
  WITH StringGrid1,S DO
  BEGIN
    Cells[0,I] := FormatDateTime (LongDateFormat,Time);
    Cells[1,I] := FormatDateTime (LongTimeFormat,Time);
    Cells[2,I] := FormatDateTime (LongTimeFormat,SysUtils.Now - Time);
    Cells[3,I] := PhoneNumber;
    Cells[4,I] := PhonebookName;
    Cells[5,I] := ServiceTxtK [Service];
    IF Outgoing THEN
      Cells[6,I] := 'Aus'
    ELSE
      Cells[6,I] := 'Ein';
  END;
END;

procedure TConnectionListForm.FormResize(Sender: TObject);
begin
  OkButton.Left := Width-115;
  ClearButton.Left := Width-220;
end;

PROCEDURE TConnectionListForm.SaveToFile;
VAR FN : STRING[255];
    I  : INTEGER;
    T  : System.TEXT;
BEGIN
  TRY
    FN := Application.ExeName;
    BYTE (FN[0]) := Pos ('.',FN);
    FN := FN + 'CNL';
    IF StringGrid1.RowCount <= 1 THEN
    BEGIN
      SysUtils.DeleteFile (FN);
    END ELSE
    BEGIN
      System.Assign (T,FN); ReWrite (T);
      TRY
        WriteLn (T,'Date'#9'Time'#9'Length'#9'Phone'#9'Name'#9'Service'#9'Type');
        StringGrid1.Cells[0,0] := 'Datum';
        FOR I := 1 TO StringGrid1.RowCount-1 DO
        BEGIN
          WriteLn (T,StringGrid1.Cells[0,I],#9,
                     StringGrid1.Cells[2,I],#9,
                     StringGrid1.Cells[2,I],#9,
                     StringGrid1.Cells[3,I],#9,
                     StringGrid1.Cells[4,I],#9,
                     StringGrid1.Cells[5,I],#9,
                     StringGrid1.Cells[6,I]);
        END;
      FINALLY
        System.Close (T);
      END;
    END;
  EXCEPT
  END;
END;


PROCEDURE TConnectionListForm.RestoreFromFile;
VAR FN : STRING[255];
    I,P: INTEGER;
    T  : System.TEXT;
    S  : STRING;
BEGIN
  TRY
    FN := Application.ExeName;
    BYTE (FN[0]) := Pos ('.',FN);
    FN := FN + 'CNL';
    System.Assign (T,FN);
    Reset (T);
    IF IOResult <> 0 THEN EXIT;
    TRY
      ReadLn (T, S);
      WHILE NOT EOF (T) DO
      BEGIN
        ReadLn (T, S);
        IF S <> '' THEN
        BEGIN
          StringGrid1.RowCount := StringGrid1.RowCount + 1;
          StringGrid1.FixedRows := 1;
          FOR I := 0 TO 6 DO
          BEGIN
            P := Pos (#9,S);
            IF P > 0 THEN
            BEGIN
              StringGrid1.Cells[I,StringGrid1.RowCount-1] := Copy (S,1,P-1);
              Delete (S,1,P);
            END ELSE
            BEGIN
              StringGrid1.Cells[I,StringGrid1.RowCount-1] := S;
              S := '';
            END;
          END;
        END;
      END;
    FINALLY
      System.Close (T);
    END;
  EXCEPT
  END;
END;

procedure TConnectionListForm.FormDestroy(Sender: TObject);
begin
  SaveToFile;
end;

PROCEDURE TConnectionListForm.LangChangedMsg (VAR Msg : TMessage);
BEGIN
  Caption := GetMsg (M_CL_CapConnLstK);

  StringGrid1.Cells[0,0] := GetMsg (M_CL_DateK);
  StringGrid1.Cells[1,0] := GetMsg (M_CL_TimeK);
  StringGrid1.Cells[2,0] := 'Dauer';
  StringGrid1.Cells[3,0] := GetMsg (M_CL_NumberK);
  StringGrid1.Cells[4,0] := GetMsg (M_CL_NameK);
  StringGrid1.Cells[5,0] := GetMsg (M_DienstK);
  StringGrid1.Cells[6,0] := GetMsg (M_TypK);

  OkButton.Caption := GetMsg (M_ButtonOkK);
  ClearButton.Caption := GetMsg (M_ButtonClearAllK);
  
END;

end.
