//  $HDR$
// **********************************************************************
//  Armin Diehl (diehl@nordrhein.de)
// **********************************************************************
//  $Log:  \\FS-AD\PRJ\GP-Version\Archives\i4l Monitor\I4lmon\Lang.pas.z 
// 
//    Rev 1.0    25.12.2000 16:46:27  ad
//  Initial Revision

// 
unit Lang;

interface

USES Windows, Forms, SysUtils, Messages;

VAR ResDllH : INTEGER = 0;

CONST ResDllNameK = 'i4lmon_%s.dll';
      CurrLang : STRING = '';
      LangChangedMsgK   = WM_User+7;
      
PROCEDURE SetLang (CONST Id : STRING);
FUNCTION  GetMsgFromHandle (ResDllH, Id : INTEGER) : STRING;
FUNCTION  GetMsg (Id : INTEGER) : STRING;

implementation



PROCEDURE SetLang (CONST Id : STRING);
VAR FN : STRING[255];
BEGIN
  FN := Application.ExeName;
  WHILE (Length (FN) > 0) AND (FN [Length(FN)] <> '\') DO
    DEC (BYTE(FN[0]));
  FN := FN + Format (ResDllNameK,[Id])+#0;
  IF ResDllH <> 0 THEN
  BEGIN
    FreeLibrary (ResDllH);
    ResDllH := 0;
  END;
  ResDllH := LoadLibrary (@FN[1]);
  IF ResDllH = 0 THEN
  BEGIN
    IF Id <> 'EN' THEN SetLang ('EN');
    IF ResDllH = 0 THEN
      RAISE (Exception.CreateFmt ('Unable to load Resource DLL (%s)',[FN]));
  END;
  CurrLang := Id;
END;

FUNCTION  GetMsgFromHandle (ResDllH, Id : INTEGER) : STRING;
VAR Buffer : ARRAY [0..1023] OF CHAR;
    nChars : INTEGER;
BEGIN
  IF ResDllH = 0 THEN SetLang ('EN');
  nChars := LoadString (ResDllH, Id, Buffer, SIZEOF (Buffer));
  SetString (Result, Buffer, nChars);
END;

FUNCTION  GetMsg (Id : INTEGER) : STRING;
BEGIN
  Result := GetMsgFromHandle (ResDllH, Id);
END;

end.
