//  $HDR$
// **********************************************************************
//  Armin Diehl (diehl@nordrhein.de)
// **********************************************************************
//  $Log:  \\FS-AD\PRJ\GP-Version\Archives\i4l Monitor\I4lmon\LanguageSelect.pas.z 
// 
//    Rev 1.0    25.12.2000 16:37:27  ad
//  Initial Revision

// 
unit LanguageSelect;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  StdCtrls, ExtCtrls, Forms, MsgConsts, Lang;

type
  TLanguageSelectForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    OkButton: TButton;
    ListBox1: TListBox;

    procedure FormCreate(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    PUBLIC
    LangId : STRING;
  end;

var
  LanguageSelectForm: TLanguageSelectForm;

implementation

{$R *.DFM}

procedure TLanguageSelectForm.FormCreate(Sender: TObject);
VAR FN,Path : STRING[255];
    F       : TSearchRec;
    Err     : INTEGER;
    H       : THandle;
    S       : STRING;
    P       : BYTE;
begin
  // Scan for all available Resource-DLL's
  Path := Application.ExeName;
  WHILE (Length (Path) > 0) AND (Path [Length(Path)] <> '\') DO
    DEC (BYTE(Path[0]));
  FN := Path + Format (ResDllNameK,['*']);
  Err := FindFirst(FN, faAnyFile, F);
  WHILE Err = 0 DO
  BEGIN
    FN := Path + F.Name + #0;
    H := LoadLibrary (@FN[1]);
    IF H <> 0 THEN
    BEGIN
      S := GetMsgFromHandle (H, M_LangNameK);
      IF S <> '' THEN
      BEGIN
        FN := F.Name;
        P := Pos ('_', FN);
        IF P > 0 THEN Delete (FN,1,P);
        P := Pos ('.', FN);
        BYTE (FN[0]) := P-1;
        ListBox1.Items.Add (FN+' - '+S);
      END;
      FreeLibrary (H);
    END;
    Err := FindNext (F);
  END;
  SysUtils.FindClose (F);
end;

procedure TLanguageSelectForm.OkButtonClick(Sender: TObject);
VAR P : INTEGER;
begin
  IF Listbox1.ItemIndex > -1 THEN
  BEGIN
    LangId := Listbox1.Items[Listbox1.ItemIndex];
    P := Pos (' ', LangId);
    IF P > 0 THEN
      LangId := Copy (LangId,1,P-1);
  END;
  ModalResult := mrOK;
end;

procedure TLanguageSelectForm.ListBox1DblClick(Sender: TObject);
begin
  OkButtonClick (Sender);
end;

end.
