//  $HDR$
// **********************************************************************
//  Armin Diehl (diehl@nordrhein.de)
// **********************************************************************
//  $Log:  \\FS-AD\PRJ\GP-Version\Archives\i4l Monitor\I4lmon\SetupForm.pas.z 
// 
//    Rev 1.1    25.12.2000 16:37:53  ad

// 
//    Rev 1.0    25.12.2000 14:42:56  ad
//  Initial Revision

// 
unit SetupForm;

// Complete Setup-Form

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Mask, Isdn4Linux, Spin, Buttons, Lang, MsgConsts;

{$I Settings.inc}

type
  TSetupFrm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    IPHostnameLabel: TLabel;
    LinuxAddrEdit: TEdit;
    ApplyButton: TButton;
    CancelButton: TButton;
    OkButton: TButton;
    PortLabel: TLabel;
    LinuxPortEdit: TMaskEdit;
    PopupIncomingCallGroupBox: TGroupBox;
    IncomingCallVoicePopup: TCheckBox;
    IncomingCallModemPopup: TCheckBox;
    IncomingCallRawPopup: TCheckBox;
    IncomingCallNetPopup: TCheckBox;
    ConnListOutGroupBox: TGroupBox;
    ConnListInGroupBox: TGroupBox;
    ShowConnOutVoice: TCheckBox;
    ShowConnOutModem: TCheckBox;
    ShowConnOutRaw: TCheckBox;
    ShowConnOutNet: TCheckBox;
    GroupBox4: TGroupBox;
    CallerList: TCheckBox;
    ShowConnInVoice: TCheckBox;
    ShowConnInModem: TCheckBox;
    ShowConnInRaw: TCheckBox;
    ShowConnInNet: TCheckBox;
    CallerListAutoShow: TCheckBox;
    HotkeyEnable: TCheckBox;
    HotkeyBox: TComboBox;
    HotkeyLabel: TLabel;
    IncomingCallShowTimeEdit: TSpinEdit;
    ShowTimeLabel: TLabel;
    FontDialog1: TFontDialog;
    FontButton: TSpeedButton;
    FontLabel: TLabel;
    FontSizeLabel: TLabel;
    FontNameEdit: TEdit;
    FontSizeEdit: TSpinEdit;
    procedure CancelButtonClick(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure ApplyButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FontButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
    PROCEDURE Uebernehmen;
  public
    { Public-Deklarationen }
    FontStyle : TFontStyles;
    PROCEDURE LangChangedMsg (VAR Msg : TMessage); Message LangChangedMsgK;
  end;

var
  SetupFrm: TSetupFrm;

implementation

USES I4lMonMainForm, IncomingCall;

{$R *.DFM}

PROCEDURE TSetupFrm.Uebernehmen;
VAR S : STRING [1];
BEGIN
  TRY
    Screen.Cursor := crHourGlass;
    MainForm.ShowCallerList := CallerList.Checked;
    MainForm.CallerListAutoShow := CallerListAutoShow.Checked;
    MainForm.ShowIncomingCalls[IS_VoiceK] := IncomingCallVoicePopup.Checked;
    MainForm.ShowIncomingCalls[IS_ModemK] := IncomingCallModemPopup.Checked;
    MainForm.ShowIncomingCalls[IS_RawK] := IncomingCallRawPopup.Checked;
    MainForm.ShowIncomingCalls[IS_NetK] := IncomingCallNetPopup.Checked;

    MainForm.ShowConnectionsOut [IS_VoiceK] := ShowConnOutVoice.Checked;
    MainForm.ShowConnectionsOut [IS_ModemK] := ShowConnOutModem.Checked;
    MainForm.ShowConnectionsOut [IS_RawK] := ShowConnOutRaw.Checked;
    MainForm.ShowConnectionsOut [IS_NetK] := ShowConnOutNet.Checked;

    MainForm.ShowConnectionsIn [IS_VoiceK] := ShowConnInVoice.Checked;
    MainForm.ShowConnectionsIn [IS_ModemK] := ShowConnInModem.Checked;
    MainForm.ShowConnectionsIn [IS_RawK] := ShowConnInRaw.Checked;
    MainForm.ShowConnectionsIn [IS_NetK] := ShowConnInNet.Checked;

    MainForm.LinuxAddrOrName := LinuxAddrEdit.Text;
    MainForm.Isdn4Linux1.LinuxPort := StrToInt (Trim(LinuxPortEdit.Text));
    //IF MainForm.Isdn4Linux1.LinuxAddrOrName <> LinuxAddrEdit.Text THEN
      MainForm.Isdn4Linux1.LinuxAddrOrName := LinuxAddrEdit.Text;

    MainForm.IncomingCallShowTime := IncomingCallShowTimeEdit.Value;

    S := Copy (HotkeyBox.Text,10,1);
    MainForm.NewHotkey (HotkeyEnable.Checked,
                     Upcase (S[1]));

    IncomingCall.FontName := FontNameEdit.Text;
    IncomingCall.FontSize := FontSizeEdit.Value;
    IncomingCall.FontStyle:= FontStyle;

    IF IncomingCallForm <> NIL THEN  // AD 6.06.2000: Can be NIL on Startup if Linux not ready
    BEGIN
      IncomingCallForm.AnrufNameLabel.Font.Name := FontNameEdit.Text;
      IncomingCallForm.AnrufNameLabel.Font.Size := FontSizeEdit.Value;
      IncomingCallForm.AnrufNameLabel.Font.Style:= FontStyle;
    END;

    MainForm.SaveWindowPos;  // save settings to ini-file

  FINALLY
    Screen.Cursor := crDefault;
  END;
END;

procedure TSetupFrm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TSetupFrm.OkButtonClick(Sender: TObject);
begin
  Uebernehmen;
  ModalResult := mrOk;
end;

procedure TSetupFrm.ApplyButtonClick(Sender: TObject);
begin
  Uebernehmen;
end;

procedure TSetupFrm.FormCreate(Sender: TObject);
begin
  {$IFNDEF AllowCallerList}
  IncomingCallVoicePopup.Enabled := FALSE;
  IncomingCallModemPopup.Enabled := FALSE;
  IncomingCallRawPopup.Enabled := FALSE;
  IncomingCallNetPopup.Enabled := FALSE;
  CallerList.Enabled := FALSE;
  CallerListAutoShow.Enabled := FALSE;
  {$ENDIF}

  {$IFNDEF AllowConnectionList}
  ShowConnOutVoice.Enabled := FALSE;
  ShowConnOutModem.Enabled := FALSE;
  ShowConnOutRaw.Enabled := FALSE;
  ShowConnOutNet.Enabled := FALSE;
  ShowConnInVoice.Enabled := FALSE;
  ShowConnInModem.Enabled := FALSE;
  ShowConnInRaw.Enabled := FALSE;
  ShowConnInNet.Enabled := FALSE;
  {$ENDIF}

  PostMessage(Handle,LangChangedMsgK,0,0);
end;

procedure TSetupFrm.FontButtonClick(Sender: TObject);
begin
  FontDialog1.Font.Size := FontSizeEdit.Value;
  FontDialog1.Font.Name := FontNameEdit.Text;
  FontDialog1.Font.Style := FontStyle;
  IF FontDialog1.Execute THEN
  BEGIN
    FontNameEdit.Text := FontDialog1.Font.Name;
    FontSizeEdit.Value:= FontDialog1.Font.Size;
    FontStyle := FontDialog1.Font.Style;
  END;
end;

PROCEDURE TSetupFrm.LangChangedMsg (VAR Msg : TMessage);
VAR S : STRING;
    I : BYTE;
BEGIN
  Caption := GetMsg (M_SF_CaptionK);
  IPHostnameLabel.Caption := GetMsg (M_SF_IPHostK);
  PortLabel.Caption := GetMsg (M_SF_PortK);
  PopupIncomingCallGroupBox.Caption := GetMsg (M_SF_PopupInK);
  ConnListOutGroupBox.Caption := GetMsg (M_SF_ConnListOutK);
  ConnListInGroupBox.Caption := GetMsg (M_SF_ConnListInK);
  IncomingCallVoicePopup.Caption := GetMsg (M_SF_VoiceK);
  ShowConnOutVoice.Caption := GetMsg (M_SF_VoiceK);
  ShowConnInVoice.Caption := GetMsg (M_SF_VoiceK);

  IncomingCallModemPopup.Caption := GetMsg (M_SF_ModemK);
  ShowConnOutModem.Caption := GetMsg (M_SF_ModemK);
  ShowConnInModem.Caption := GetMsg (M_SF_ModemK);
  IncomingCallRawPopup.Caption := GetMsg (M_SF_RawK);
  ShowConnOutRaw.Caption := GetMsg (M_SF_RawK);
  ShowConnInRaw.Caption := GetMsg (M_SF_RawK);
  IncomingCallNetPopup.Caption := GetMsg (M_SF_NetK);
  ShowConnOutNet.Caption := GetMsg (M_SF_NetK);
  ShowConnInNet.Caption := GetMsg (M_SF_NetK);

  ShowTimeLabel.Caption := GetMsg (M_SF_ShowTomeK);
  FontLabel.Caption := GetMsg (M_SF_FontK);
  FontSizeLabel.Caption := GetMsg (M_SF_FontSizeK);
  CallerList.Caption := GetMsg (M_SF_CallerListK);
  CallerListAutoShow.Caption := GetMsg (M_SF_CallerLAutoK);
  HotkeyEnable.Caption := GetMsg (M_SF_InsHotkeyK);
  HotkeyLabel.Caption := GetMsg (M_SF_HotkeyK);
  OkButton.Caption := GetMsg (M_ButtonOkK);
  CancelButton.Caption := GetMsg (M_ButtonCancelK);
  ApplyButton.Caption := GetMsg (M_ButtonApplyK);

  S := GetMsg (M_SF_StrgAltK);
  HotkeyBox.Items.Clear;
  FOR I := BYTE ('A') TO BYTE ('Z') DO
    HotkeyBox.Items.Add (S+' '+CHAR(I));

END;



END.
