//  $HDR$
// **********************************************************************
//  Armin Diehl (diehl@nordrhein.de)
// **********************************************************************
//  $Log:  \\FS-AD\PRJ\GP-Version\Archives\i4l Monitor\I4lmon\SetupFormSimple.pas.z 
// 
//    Rev 1.0    25.12.2000 16:38:08  ad
//  Initial Revision

// 
unit SetupFormSimple;

// Simple Setup-Form only with IP and Hotkey

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Mask, Isdn4Linux,
  Lang, MsgConsts;

type
  TSetupFrm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    IPHostnameLabel: TLabel;
    LinuxAddrEdit: TEdit;
    ApplyButton: TButton;
    CancelButton: TButton;
    OkButton: TButton;
    PortLabel: TLabel;
    LinuxPortEdit: TMaskEdit;
    GroupBox4: TGroupBox;
    HotkeyEnable: TCheckBox;
    HotkeyBox: TComboBox;
    HotkeyLabel: TLabel;
    procedure CancelButtonClick(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure ApplyButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    PROCEDURE Uebernehmen;
  public
    { Public-Deklarationen }
    PROCEDURE LangChangedMsg (VAR Msg : TMessage); Message LangChangedMsgK;
  end;

var
  SetupFrm: TSetupFrm;

implementation

USES I4lMonMainForm;

{$R *.DFM}

PROCEDURE TSetupFrm.Uebernehmen;
VAR S : STRING [1];
BEGIN
  TRY
    Screen.Cursor := crHourGlass;

    MainForm.LinuxAddrOrName := LinuxAddrEdit.Text;
    MainForm.Isdn4Linux1.LinuxPort := StrToInt (Trim(LinuxPortEdit.Text));
    IF MainForm.Isdn4Linux1.LinuxAddrOrName <> LinuxAddrEdit.Text THEN
      MainForm.Isdn4Linux1.LinuxAddrOrName := LinuxAddrEdit.Text;

    S := Copy (HotkeyBox.Text,10,1);
    MainForm.NewHotkey (HotkeyEnable.Checked,
                     Upcase (S[1]));

  FINALLY
    Screen.Cursor := crDefault;
  END;
END;

procedure TSetupFrm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TSetupFrm.OkButtonClick(Sender: TObject);
begin
  Uebernehmen;
  ModalResult := mrOk;
end;

procedure TSetupFrm.ApplyButtonClick(Sender: TObject);
begin
  Uebernehmen;
end;

PROCEDURE TSetupFrm.LangChangedMsg (VAR Msg : TMessage);
VAR S : STRING;
    I : BYTE;
BEGIN
  Caption := GetMsg (M_SF_CaptionK);
  IPHostnameLabel.Caption := GetMsg (M_SF_IPHostK);
  PortLabel.Caption := GetMsg (M_SF_PortK);
  HotkeyEnable.Caption := GetMsg (M_SF_InsHotkeyK);
  HotkeyLabel.Caption := GetMsg (M_SF_HotkeyK);
  OkButton.Caption := GetMsg (M_ButtonOkK);
  CancelButton.Caption := GetMsg (M_ButtonCancelK);
  ApplyButton.Caption := GetMsg (M_ButtonApplyK);

  S := GetMsg (M_SF_StrgAltK);
  HotkeyBox.Items.Clear;
  FOR I := BYTE ('A') TO BYTE ('Z') DO
    HotkeyBox.Items.Add (S+' '+CHAR(I));

END;

procedure TSetupFrm.FormCreate(Sender: TObject);
begin
  PostMessage(Handle,LangChangedMsgK,0,0);
end;

end.
