//  $HDR$
// **********************************************************************
//  Armin Diehl (diehl@nordrhein.de)
// **********************************************************************
//  $Log:  \\FS-AD\PRJ\GP-Version\Archives\i4l Monitor\I4lmon\TelefonnummernForm.pas.z 
// 
//    Rev 1.1    25.12.2000 16:46:54  ad
//  Language support

// 
//    Rev 1.0    24.12.2000 15:22:25  ad
//  Initial Revision

// 
unit TelefonnummernForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, isdn4Linux, NeueNummerFrm,
  Lang, MsgConsts;

type
  TNummernForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    InterfaceLabel: TLabel;
    IfComboBox: TComboBox;
    NummernListBox: TListBox;
    ListboxCaptionLabel: TLabel;
    DeleteButton: TButton;
    NewButton: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure IfComboBoxChange(Sender: TObject);
    procedure NummernListBoxClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
    procedure NewButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private-Deklarationen }
    i4l : TIsdn4Linux;

    PROCEDURE FillNummernBox;
  public
    { Public-Deklarationen }
    PROCEDURE Init (Linux : TIsdn4Linux);
    PROCEDURE LangChangedMsg (VAR Msg : TMessage); Message LangChangedMsgK;
  end;

var
  NummernForm: TNummernForm;

implementation

{$R *.DFM}

PROCEDURE TNummernForm.Init (Linux : TIsdn4Linux);
VAR I : INTEGER;
BEGIN
  i4l := Linux;
  IfComboBox.Items.Clear;
  IfComboBox.Text := '';

  IF i4l.InterfaceCount > 0 THEN
    FOR I := 0 TO i4l.InterfaceCount-1 DO
      IfComboBox.Items.Add (i4l.InterfaceNames [I]);
END;

PROCEDURE TNummernForm.FillNummernBox;
VAR IfName : STRING;
    I      : INTEGER;
    Numbers: STRING;
    P      : INTEGER;
BEGIN
  IfName := IfComboBox.Text;
  NummernListBox.Clear;

  IF i4l.InterfaceCount > 0 THEN
    FOR I := 0 TO i4l.InterfaceCount-1 DO
      IF i4l.InterfaceNames [I] = IfName THEN
      BEGIN
        Numbers := i4l.InterfaceOutNumbers [I];
        P := Pos (' ', Numbers);
        WHILE P > 0 DO
        BEGIN
          NummernListBox.Items.Add ('Aus: '+Copy (Numbers,1,P-1));
          Delete (Numbers,1,P);
          P := Pos (' ', Numbers);
        END;
        IF Numbers <> '' THEN
          NummernListBox.Items.Add ('Aus: '+Numbers);

        Numbers := i4l.InterfaceInNumbers [I];
        P := Pos (' ', Numbers);
        WHILE P > 0 DO
        BEGIN
          NummernListBox.Items.Add ('Ein: '+Copy (Numbers,1,P-1));
          Delete (Numbers,1,P);
          P := Pos (' ', Numbers);
        END;
        IF Numbers <> '' THEN
          NummernListBox.Items.Add ('Ein: '+Numbers);

        DeleteButton.Enabled := NummernListBox.ItemIndex > -1;

        EXIT;
      END;
END;

procedure TNummernForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  NummernForm := NIL;
  Free;
end;

procedure TNummernForm.IfComboBoxChange(Sender: TObject);
begin
  FillNummernBox;
end;

procedure TNummernForm.NummernListBoxClick(Sender: TObject);
begin
  DeleteButton.Enabled := NummernListBox.ItemIndex > -1;
end;

procedure TNummernForm.DeleteButtonClick(Sender: TObject);
VAR Num      : STRING;
    Outgoing : BOOLEAN;
    Resu     : STRING;
begin
  IF NummernListBox.ItemIndex > -1 THEN
  BEGIN
    Num := NummernListBox.Items [NummernListBox.ItemIndex];
    Outgoing := (Copy (Num,1,1) = 'A');
    Delete (Num,1,5);
    Resu := i4l.i4ld_DelNumber (IfComboBox.Text, Num, Outgoing);
    IF Copy (Resu,1,6) = '!ERROR' THEN
    BEGIN
      Resu := 'Nummer konnte leider nicht gelscht werden ('+Resu+')';
      Application.MessageBox (PChar(Resu),'Problem',MB_Ok + MB_IconExclamation);
    END;
    FillNummernBox;
  END;
end;

procedure TNummernForm.NewButtonClick(Sender: TObject);
VAR IfName : STRING;
    NrFrm  : TNeueNummerForm;
    Resu   : INTEGER;
    Outgoing : BOOLEAN;
    Number   : STRING;
    Resu2    : STRING;
begin
  IfName := IfComboBox.Text;
  IF IfName <> '' THEN
  BEGIN
    NrFrm := NIL;
    TRY
      NrFrm := TNeueNummerForm.Create (SELF);
      NrFrm.Caption := Format (GetMsg (M_PN_NewCaptionK), [IfName]);
      Resu := NrFrm.ShowModal;
      IF Resu = mrOK THEN
      BEGIN
        Outgoing := NOT NrFrm.EingehendeNummer.Checked;
        Number := NrFrm.NummerEdit.Text;
        Resu2 := i4l.i4ld_AddNumber (IfName, Number, Outgoing);
        IF Copy (Resu2,1,6) = '!ERROR' THEN
        BEGIN
          Resu2 := 'Nummer konnte leider nicht hinzugefgt werden ('+Resu2+')';
          Application.MessageBox (PChar(Resu2),'Problem',MB_Ok + MB_IconExclamation);
        END;  
      END;
    FINALLY
      NrFrm.Free;
    END;
    FillNummernBox;
  END;
end;

PROCEDURE TNummernForm.LangChangedMsg (VAR Msg : TMessage);
BEGIN
  Caption := GetMsg (M_PN_CaptionK);
  InterfaceLabel.Caption := GetMsg (M_PN_InterfaceK);
  ListboxCaptionLabel.Caption := GetMsg (M_PN_ListBoxLabK);
  DeleteButton.Caption := GetMsg (M_ButtonDeleteK);
  NewButton.Caption := GetMsg (M_PN_NewNumberK);
END;


procedure TNummernForm.FormCreate(Sender: TObject);
begin
  PostMessage(Handle,LangChangedMsgK,0,0);
end;

end.
