unit Isdn4LinuxTestMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Isdn4Linux;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    LnxAdrEdit: TEdit;
    PortEdit: TEdit;
    ConnectButton: TButton;
    ListBox1: TListBox;
    Label2: TLabel;

    PortButton: TButton;
    Isdn4Linux1: TIsdn4Linux;
    ConnectedCheckBox: TCheckBox;
    Label3: TLabel;
    IfEdit: TEdit;
    DialButton: TButton;
    HangupButton: TButton;
    procedure Isdn4Linux1LinuxConnect(Sender: TObject);
    procedure Isdn4Linux1LinuxDisconnect(Sender: TObject);
    procedure Isdn4Linux1Connect(Sender: TObject;
      var NewStatus: TIsdnStatus);
    procedure Isdn4Linux1Disconnect(Sender: TObject; var NewStatus,
      OldStatus: TIsdnStatus);
    procedure Isdn4Linux1Dial(Sender: TObject; var NewStatus: TIsdnStatus);
    procedure Isdn4Linux1Ring(Sender: TObject; var NewStatus: TIsdnStatus);
    procedure Isdn4Linux1StatusChange(Sender: TObject; var NewStatus,
      OldStatus: TIsdnStatus);
    procedure ConnectButtonClick(Sender: TObject);
    procedure PortButtonClick(Sender: TObject);
    procedure Isdn4Linux1Terminate(Sender: TObject; var NewStatus,
      OldStatus: TIsdnStatus);
    procedure DialButtonClick(Sender: TObject);
    procedure HangupButtonClick(Sender: TObject);
    procedure Isdn4Linux1BChannelChange(Sender: TObject;
      DriverLoaded: Boolean; DriverNum, B1, B2: Byte);
  private
    PROCEDURE ShowMsg (Msg : STRING; Parms : ARRAY OF CONST);
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

TYPE Str10 = STRING [10];
CONST StatusTxtK : ARRAY [IS_NoneK..IS_VoiceK] OF Str10 =
  ('Frei','Raw','Modem','Net','Voice');

PROCEDURE TForm1.ShowMsg (Msg : STRING; Parms : ARRAY OF CONST);
BEGIN
  Listbox1.Items.Add (Format (Msg,Parms));
  Listbox1.ItemIndex := Listbox1.Items.Count -1;
END;

procedure TForm1.Isdn4Linux1LinuxConnect(Sender: TObject);
VAR I : INTEGER;
begin
  ConnectedCheckBox.Checked := TRUE;
  ShowMsg ('OnLinuxConnect %d',[1]);
  IF Isdn4Linux1.InterfaceCount > 0 THEN
    FOR I := 1 TO Isdn4Linux1.InterfaceCount DO
      ShowMsg ('Interface: "%s"',[Isdn4Linux1.InterfaceNames[I-1]]);
  ShowMsg ('i4lmond Version "%s"',[Isdn4Linux1.i4ldVersion]);
end;

procedure TForm1.Isdn4Linux1LinuxDisconnect(Sender: TObject);
begin
  ConnectedCheckBox.Checked := FALSE;
  ShowMsg ('OnLinuxDisconnect %d',[1]);
end;

procedure TForm1.Isdn4Linux1Connect(Sender: TObject;
  var NewStatus: TIsdnStatus);
begin
  WITH NewStatus DO
    ShowMsg ('Connect: Index:%d, Service:%s, Phone:%s, Outgoing:%d',[Index,StatusTxtK[Service],PhoneNumber,BYTE(Outgoing)]);
end;

procedure TForm1.Isdn4Linux1Disconnect(Sender: TObject; var NewStatus,
  OldStatus: TIsdnStatus);
begin
  WITH OldStatus DO
    ShowMsg ('Disconnect Index:%d, Phone:%s',[Index,PhoneNumber]);
end;

procedure TForm1.Isdn4Linux1Dial(Sender: TObject;
  var NewStatus: TIsdnStatus);
begin
  WITH NewStatus DO
    ShowMsg ('Dial: Index:%d, Service:%s Phone:%s',[Index,StatusTxtK[Service],PhoneNumber]);
end;

procedure TForm1.Isdn4Linux1Ring(Sender: TObject;
  var NewStatus: TIsdnStatus);
begin
  WITH NewStatus DO
    ShowMsg ('Ring: Index:%d, Service:%s Phone:%s',[Index,StatusTxtK[Service],PhoneNumber]);
end;

procedure TForm1.Isdn4Linux1StatusChange(Sender: TObject; var NewStatus,
  OldStatus: TIsdnStatus);
begin
  WITH NewStatus DO
    ShowMsg ('StatusChange: Index:%d, Service:%s Phone:%s',[Index,StatusTxtK[Service],PhoneNumber]);
end;

procedure TForm1.ConnectButtonClick(Sender: TObject);
begin
  Isdn4Linux1.LinuxAddrOrName := LnxAdrEdit.Text;
end;

procedure TForm1.PortButtonClick(Sender: TObject);
begin
  Isdn4Linux1.LinuxPort := StrToInt (PortEdit.Text);
end;

procedure TForm1.Isdn4Linux1Terminate(Sender: TObject; var NewStatus,
  OldStatus: TIsdnStatus);
begin
  WITH OldStatus DO
    ShowMsg ('OnTerminate: Index:%d, oldService:%s oldPhone:%s',[Index,StatusTxtK[Service],PhoneNumber]);
end;

procedure TForm1.DialButtonClick(Sender: TObject);
begin
  Isdn4Linux1.Dial (IfEdit.Text);
end;

procedure TForm1.HangupButtonClick(Sender: TObject);
begin
  Isdn4Linux1.Hangup (IfEdit.Text);
end;

procedure TForm1.Isdn4Linux1BChannelChange(Sender: TObject;
  DriverLoaded: Boolean; DriverNum, B1, B2: Byte);
begin
  ShowMsg ('BChannelChange, Driver:%d, Loaded:%d, B1:%d, B2:%d',[DriverNum,BYTE(DriverLoaded),B1,B2]);
end;

end.
