//  $HDR$
// **********************************************************************
//  Armin Diehl (diehl@nordrhein.de)
// **********************************************************************
//  $Log:  \\FS-AD\PRJ\GP-Version\Archives\i4l Monitor\I4lmon\i4lMonMainForm.pas.z 
// 
//    Rev 1.2    19.01.2001 21:24:49  ad
//  there was no call to Isdn4Linux1.i4ld_DisConnect (thanks to 
//  Stefan Dringenberg <dringenberg@gmx.net>)

// 
//    Rev 1.1    25.12.2000 16:38:40  ad

// 
//    Rev 1.0    24.12.2000 15:22:30  ad
//  Initial Revision

// 
unit i4lMonMainForm;

(*
 changelog:
 ad  3.10.1998: Cpmplete Redisign, Most work now in Component TIsdn4Linux
 ad 27.09.1998: ippp info, phonebook
 ad 26.09.1998: icons/dial/hangup
 ad 22.10.1998: disconnect/reconnect
 ad 15.11.1998: dialmode
 ad 04.04.1999: addlink, removelink
                hotkey
                Close of Status-Window will no longer terminate program
 ad 17.04.1999: Logoff and Shutdown blocked in previus version because
                MainWindow not closed
 ad 24.12.1999: Show incoming calls from /var/log/messages,
                on Linux cat /dev/isdninfo must be replaced by
                isdninfo (daemon)

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 Win32 Verbindungsmonitor (like imon) fr Win32
 12.10.1998 Armin Diehl (diehl@net-connection.de)
*)
{$R ISDNICONS.RES}

interface

{$I Settings.inc}


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls,
  Isdn4Linux, StdCtrls, Grids, IniFiles, ShellApi, Menus,
  ListForm, Aboutbox, Winsock, Lang, MsgConsts, LanguageSelect
  {$IFDEF UseSimpleSetupForm}
  ,SetupFormSimple
  {$ELSE}
  ,SetupForm
  {$ENDIF}
  {$IFDEF AllowCallerList}     ,IncomingCall        {$ENDIF}
  {$IFDEF AllowConnectionList} ,ConnectionList      {$ENDIF}
  {$IFDEF AllowChangeNumbers}  ,TelefonnummernForm  {$ENDIF}
  ;

// if set, incoming calls from /var/log/messages will be used. Otherwise
// /dev/isdninfo is used
{$DEFINE ShowCallsFromMessages}

CONST NotConnectedK  = 'nicht verbunden';
      SysTrayMsgK    = WM_User+5;
      VersionK       = '0.96 - 19 Jan 2001';




type
  IconNumsT = ARRAY [0..I4LMaxCardsK-1] OF BYTE;

  TMainForm = class(TForm)
    StringGrid1: TStringGrid;
    SysTrayMenu: TPopupMenu;
    i4lMonitorb1: TMenuItem;
    SysTrayMen_AlwaysOnTop: TMenuItem;
    SysTrayMen_Show: TMenuItem;
    SysTrayMen_Hide: TMenuItem;
    SysTrayMen_Dial: TMenuItem;
    SysTrayMen_Hangup: TMenuItem;
    SysTrayMen_Info: TMenuItem;
    SysTrayMen_About: TMenuItem;
    SysTrayMen_Setup: TMenuItem;
    SysTrayMen_CallerList: TMenuItem;
    SysTrayMen_ConnectionList: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;

    Isdn4Linux1: TIsdn4Linux;
    SysTrayMen_Dialmode: TMenuItem;
    SysTrayMen_Numbers: TMenuItem;
    SysTrayMen_AddLink: TMenuItem;
    SysTrayMen_RemoveLink: TMenuItem;
    IncomingCallCloseTimer: TTimer;
    SysTrayMen_SelectLanguage: TMenuItem;



    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SysTrayMen_AlwaysOnTopClick(Sender: TObject);
    procedure SysTrayMen_ShowClick(Sender: TObject);
    procedure SysTrayMen_HideClick(Sender: TObject);
    procedure i4lMonitorb1Click(Sender: TObject);
    procedure SysTrayMen_AboutClick(Sender: TObject);
    procedure Isdn4Linux1BChannelChange(Sender: TObject;
      DriverLoaded: Boolean; DriverNum, B1, B2: Byte);
    procedure Isdn4Linux1StatusChange(Sender: TObject; var NewStatus,
      OldStatus: TIsdnStatus);
    procedure Isdn4Linux1LinuxDisconnect(Sender: TObject);
    procedure Isdn4Linux1LinuxConnect(Sender: TObject);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SysTrayMen_SetupClick(Sender: TObject);
    procedure Isdn4Linux1Ring(Sender: TObject; var NewStatus: TIsdnStatus);
    procedure Isdn4Linux1Connect(Sender: TObject;
      var NewStatus: TIsdnStatus);
    procedure Isdn4Linux1Terminate(Sender: TObject; var NewStatus,
      OldStatus: TIsdnStatus);
    procedure SysTrayMen_CallerListClick(Sender: TObject);
    procedure Isdn4Linux1Disconnect(Sender: TObject; var NewStatus,
      OldStatus: TIsdnStatus);
    procedure SysTrayMen_ConnectionListClick(Sender: TObject);
    procedure SysTrayMen_NumbersClick(Sender: TObject);
    procedure IncomingCallCloseTimerTimer(Sender: TObject);
    procedure Isdn4Linux1UnboundCall(Sender: TObject; CallFrom,
      CallTo: String; Service: Ti4lService);
    procedure SysTrayMen_SelectLanguageClick(Sender: TObject);
  private

    IconHintText       : STRING;
    TaskBarIcons       : ARRAY [0..9] OF THandle;  // 9=Strung
    TData              : TNotifyIconData;          // fr die Message an SysTray
    ActiveTaskBarIcons : IconNumsT; // $FF=not Shown otherwise 0..9
    HotkeyEnabled      : BOOLEAN;
    Hotkey             : CHAR;      // Ctrl,Alt + Hotkey
    HotkeyRegistred    : BOOLEAN;
    TerminateAllowed   : BOOLEAN;   // Set by Systray-Menu to prevent quitting when closing Status-Win
    {$IFDEF AllowCallerList}
    LastUBCallFrom,
    LastUBCallFromName,
    LastUBCallTo       : STRING;
    LastUBService      : Ti4lService;
    {$ENDIF}

    PUBLIC
    PROCEDURE NewHotkey (Ena : BOOLEAN;
                         Hot : CHAR);
    PROCEDURE SaveWindowPos;
    PROCEDURE SaveLanguage;

    PRIVATE
    PROCEDURE OnEndWindows (VAR Msg : TMessage); MESSAGE WM_QUERYENDSESSION;

    // Meldungen vom SysTray-Icon
    PROCEDURE TBarMsg (VAR Msg : TMessage); Message SysTrayMsgK;
    PROCEDURE LangChangedMsg (VAR Msg : TMessage); Message LangChangedMsgK;

    PROCEDURE RestoreWindowPos;

    PROCEDURE ShowSysTrayIcon  (DriverNum : BYTE;
                                IconType  : BYTE);
    PROCEDURE DisableSysTrayIcons;

    FUNCTION  GetIpppNameFormMenu (T : TMenuItem) : STRING;
    // Menu Dial/Hangup
    PROCEDURE SysTrayMen_DialClick (Sender: TObject);
    PROCEDURE SysTrayMen_DialmodeClick (Sender: TObject);
    PROCEDURE SysTrayMen_HangupClick (Sender: TObject);
    PROCEDURE SysTrayMen_InfoClick (Sender: TObject);
    PROCEDURE SysTrayMen_AddLinkClick (Sender: TObject);
    PROCEDURE SysTrayMen_RemoveLinkClick (Sender: TObject);

    PROCEDURE OnHotkey (VAR Msg : TMessage); MESSAGE WM_HOTKEY;
  public

    LinuxAddrOrName    : STRING;
    ShowIncomingCalls  : ARRAY [IS_NoneK..IS_VoiceK] OF BOOLEAN;
    ShowCallerList     : BOOLEAN;
    CallerListAutoShow : BOOLEAN;
    ShowConnectionsOut : ARRAY [IS_NoneK..IS_VoiceK] OF BOOLEAN;
    ShowConnectionsIn  : ARRAY [IS_NoneK..IS_VoiceK] OF BOOLEAN;
    {$IFDEF ShowCallsFromMessages}
      // because we only get a message for incoming calls we need a timer
      // to close the incoming call window
    IncomingCallShowTime : INTEGER;
    {$ENDIF}
  end;

var
  MainForm: TMainForm;

implementation

uses Anruferliste;

{$R *.DFM}


// Save Window Position, Size und Stringgrid
PROCEDURE TMainForm.SaveWindowPos;
VAR T  : TIniFile;
    FN : STRING [255];
    I  : INTEGER;
BEGIN
  FN := Application.ExeName;
  BYTE (FN[0]) := Pos ('.',FN);
  FN := FN + 'INI';               // wie das Programm nur halt ini
  T := TIniFile.Create (FN);
  T.WriteInteger ('WINPOS','X', Left);
  T.WriteInteger ('WINPOS','Y', Top);
  T.WriteInteger ('WINPOS','Width', Width);
  T.WriteInteger ('WINPOS','Height', Height);
  T.WriteInteger ('WINPOS','AlwaysOnTop', BYTE (BOOLEAN (FormStyle = fsStayOnTop)));

  {$IFDEF AllowCallerList}
  IF IncomingCallForm <> NIL THEN
  BEGIN
    T.WriteInteger ('POPUPWINPOS','X', IncomingCallForm.Left);
    T.WriteInteger ('POPUPWINPOS','Y', IncomingCallForm.Top);
  END;
  {$ENDIF}

  FOR I := 0 TO StringGrid1.ColCount DO
    T.WriteInteger ('CollWidth',IntToStr(I), StringGrid1.ColWidths[I]);
  T.WriteString ('Linux','Addr',LinuxAddrOrName);

  T.WriteInteger ('OPTIONS','ShowIncomingCallNet',BYTE(ShowIncomingCalls[IS_NetK]));
  T.WriteInteger ('OPTIONS','ShowIncomingCallVoice',BYTE(ShowIncomingCalls[IS_VoiceK]));
  T.WriteInteger ('OPTIONS','ShowIncomingCallRaw',BYTE(ShowIncomingCalls[IS_RawK]));
  T.WriteInteger ('OPTIONS','ShowIncomingCallModem',BYTE(ShowIncomingCalls[IS_ModemK]));
  T.WriteInteger ('OPTIONS','ShowCallerList',BYTE(ShowCallerList));
  T.WriteInteger ('OPTIONS','CallerListAutoShow',BYTE(CallerListAutoShow));

  T.WriteInteger ('OPTIONS','ShowConnectionsOutNet',BYTE(ShowConnectionsOut[IS_NetK]));
  T.WriteInteger ('OPTIONS','ShowConnectionsOutVoice',BYTE(ShowConnectionsOut[IS_VoiceK]));
  T.WriteInteger ('OPTIONS','ShowConnectionsOutRaw',BYTE(ShowConnectionsOut[IS_RawK]));
  T.WriteInteger ('OPTIONS','ShowConnectionsOutModem',BYTE(ShowConnectionsOut[IS_ModemK]));

  T.WriteInteger ('OPTIONS','ShowConnectionsInNet',BYTE(ShowConnectionsIn[IS_NetK]));
  T.WriteInteger ('OPTIONS','ShowConnectionsInVoice',BYTE(ShowConnectionsIn[IS_VoiceK]));
  T.WriteInteger ('OPTIONS','ShowConnectionsInRaw',BYTE(ShowConnectionsIn[IS_RawK]));
  T.WriteInteger ('OPTIONS','ShowConnectionsInModem',BYTE(ShowConnectionsIn[IS_ModemK]));

  T.WriteBool    ('OPTIONS','HotkeyEnabled', HotkeyEnabled);
  T.WriteInteger ('OPTIONS','Hotkey',BYTE(Hotkey));
  T.WriteInteger ('OPTIONS','IncomingCallShowTime',IncomingCallShowTime);
  {$IFDEF AllowCallerList}
  T.WriteString  ('OPTIONS','IncomingCallFont',IncomingCall.FontName);
  T.WriteInteger ('OPTIONS','IncomingCallFontSize',IncomingCall.FontSize);
  T.WriteInteger ('OPTIONS','IncomingCallFontStyle',BYTE(IncomingCall.FontStyle));
  {$ENDIF}
  T.Free;
END;


PROCEDURE TMainForm.SaveLanguage;
VAR T  : TIniFile;
    FN : STRING [255];
BEGIN
  FN := Application.ExeName;
  BYTE (FN[0]) := Pos ('.',FN);
  FN := FN + 'INI';               // wie das Programm nur halt ini
  T := TIniFile.Create (FN);
  T.WriteString ('OPTIONS','LANGUAGE', Lang.CurrLang);
  T.Free;
  PostMessage(Handle,LangChangedMsgK,0,0);
END;


FUNCTION SelectLang : STRING;
VAR LangForm : TLanguageSelectForm;
begin
  LangForm := NIL;
  TRY
    LangForm := TLanguageSelectForm.Create (MainForm);
    LangForm.ShowModal;
    Result := LangForm.LangId;
  FINALLY
    LangForm.Free;
  END;
end;



PROCEDURE TMainForm.RestoreWindowPos;
VAR T  : TIniFile;
    FN : STRING [255];
    I  : INTEGER;
    S  : STRING;
BEGIN
  FN := Application.ExeName;
  BYTE (FN[0]) := Pos ('.',FN);
  FN := FN + 'INI';
  T := NIL;
  TRY
    T := TIniFile.Create (FN);

    S := T.ReadString ('OPTIONS','LANGUAGE', '');
    IF S = '' THEN
    BEGIN
      REPEAT
        S := SelectLang;
      UNTIL S <> '';
      Lang.SetLang (S);
      T.WriteString ('OPTIONS','LANGUAGE', S);
    END ELSE
      Lang.SetLang (S);

    ShowIncomingCalls[IS_NetK] := (T.ReadInteger ('OPTIONS','ShowIncomingCallNet',0) = 1);
    ShowIncomingCalls[IS_VoiceK] := (T.ReadInteger ('OPTIONS','ShowIncomingCallVoice',0) = 1);
    ShowIncomingCalls[IS_RawK] := (T.ReadInteger ('OPTIONS','ShowIncomingCallRaw',0) = 1);
    ShowIncomingCalls[IS_ModemK] := (T.ReadInteger ('OPTIONS','ShowIncomingCallModem',0) = 1);
    ShowCallerList := (T.ReadInteger ('OPTIONS','ShowCallerList',0) = 1);
    CallerListAutoShow := (T.ReadInteger ('OPTIONS','CallerListAutoShow',0) = 1);

    ShowConnectionsOut[IS_NetK] := (T.ReadInteger ('OPTIONS','ShowConnectionsOutNet',0) = 1);
    ShowConnectionsOut[IS_VoiceK] := (T.ReadInteger ('OPTIONS','ShowConnectionsOutVoice',0) = 1);
    ShowConnectionsOut[IS_RawK] := (T.ReadInteger ('OPTIONS','ShowConnectionsOutRaw',0) = 1);
    ShowConnectionsOut[IS_ModemK] := (T.ReadInteger ('OPTIONS','ShowConnectionsOutModem',0) = 1);

    ShowConnectionsIn[IS_NetK] := (T.ReadInteger ('OPTIONS','ShowConnectionsInNet',0) = 1);
    ShowConnectionsIn[IS_VoiceK] := (T.ReadInteger ('OPTIONS','ShowConnectionsInVoice',0) = 1);
    ShowConnectionsIn[IS_RawK] := (T.ReadInteger ('OPTIONS','ShowConnectionsInRaw',0) = 1);
    ShowConnectionsIn[IS_ModemK] := (T.ReadInteger ('OPTIONS','ShowConnectionsInModem',0) = 1);
    IncomingCallShowTime := T.ReadInteger ('OPTIONS','IncomingCallShowTime',5);

    HotkeyEnabled := T.ReadBool ('OPTIONS','HotkeyEnabled', TRUE);
    Hotkey := CHAR (T.ReadInteger ('OPTIONS','Hotkey',BYTE('I')));

    Left := T.ReadInteger ('WINPOS','X', Left);
    IF Left > Screen.Width-5 THEN
      Left := Screen.Width-5;
    Top := T.ReadInteger ('WINPOS','Y', Top);
    IF Top > Screen.Height-5 THEN
      Top := Screen.Height-5;
    Width := T.ReadInteger ('WINPOS','Width', Width);
    Height := T.ReadInteger ('WINPOS','Height', Height);
    IF T.ReadInteger ('WINPOS','AlwaysOnTop', 0) <> 0 THEN
    BEGIN
      FormStyle := fsStayOnTop;
      SysTrayMen_AlwaysOnTop.Checked := TRUE;
    END;

    {$IFDEF AllowCallerList}
    IncomingCall.XPos := T.ReadInteger ('POPUPWINPOS','X', Left);
    IF IncomingCall.XPos > Screen.Width-5 THEN
      IncomingCall.XPos := Screen.Width-5;
    IncomingCall.YPos := T.ReadInteger ('POPUPWINPOS','Y', Top);
    IF IncomingCall.YPos > Screen.Height-5 THEN
      IncomingCall.YPos := Screen.Height-5;
    S := T.ReadString  ('OPTIONS','IncomingCallFont','');
    IF S <> '' THEN
      IncomingCall.FontName := S;

    I := T.ReadInteger ('OPTIONS','IncomingCallFontSize',0);
    IF I > 0 THEN
      IncomingCall.FontSize := I;
    I := T.ReadInteger ('OPTIONS','IncomingCallFontStyle',-1);
    IF I <> -1 THEN IncomingCall.FontStyle := TFontStyles(BYTE(I));

    {$ENDIF}

    FOR I := 0 TO StringGrid1.ColCount-1 DO
      StringGrid1.ColWidths[I] := T.ReadInteger ('CollWidth',IntToStr(I),StringGrid1.ColWidths[I]);
    TRY
      Isdn4Linux1.SetErrorText (GetMsg (M_CO_UnabConnK));
      Isdn4Linux1.LinuxPort := T.ReadInteger ('Linux','Port', Isdn4Linux.I4LDefPortK);
      LinuxAddrOrName := T.ReadString ('Linux','Addr','127.0.0.1');
      Isdn4Linux1.LinuxAddrOrName := LinuxAddrOrName;
    EXCEPT
      ON E:Exception DO
      BEGIN
        Application.MessageBox (PChar(E.Message),PChar(GetMsg (M_ProblemK)),MB_Ok + MB_IconExclamation);
        TRY
          SysTrayMen_SetupClick (SELF);
        EXCEPT
        END;
      END;
    END;
  FINALLY
    T.Free;
    IF NOT Isdn4Linux1.Connected THEN
      Isdn4Linux1LinuxDisconnect(SELF);
  END;
END;


PROCEDURE TMainForm.OnEndWindows (VAR Msg : TMessage);
BEGIN
  TerminateAllowed := TRUE;
  INHERITED;
  PostQuitMessage (0);
END;


procedure TMainForm.TBarMsg (VAR Msg : TMessage);
VAR Posi        : TPoint;
    T,T1        : TMenuItem;
    I,J         : INTEGER;
    Numbers,
    Ifname      : STRING;
    Status      : TInterfaceConnectStatus;
    {$IFDEF AllowDialmode}
    Dialmode    : STRING;
    hasDialmode : BOOLEAN;
    {$ENDIF}
BEGIN
  GetCursorPos (Posi);

  CASE Msg.lParam OF
    WM_RBUTTONDOWN  : BEGIN
                        IF Visible THEN
                        BEGIN
                          SysTrayMen_Show.Enabled := FALSE;
                          SysTrayMen_Hide.Enabled := TRUE;
                        END ELSE
                        BEGIN
                          SysTrayMen_Show.Enabled := TRUE;
                          SysTrayMen_Hide.Enabled := FALSE;
                        END;

                        // AD 06.06.2000: May be we lost connection
                        IF NOT Isdn4Linux1.i4ld_TestConnected THEN
                          Isdn4Linux1.i4ld_Connect;  // try to reconnect

                        // Set Menu in selected Language

                        SysTrayMen_AlwaysOnTop.Caption := GetMsg (M_AlwaysOnTopK);
                        SysTrayMen_Show.Caption := GetMsg (M_ShowK);
                        SysTrayMen_Hide.Caption := GetMsg (M_HideK);
                        SysTrayMen_Dial.Caption := GetMsg (M_DialK);
                        SysTrayMen_Hangup.Caption := GetMsg (M_HangupK);
                        SysTrayMen_Info.Caption := GetMsg (M_InfoK);
                        SysTrayMen_About.Caption := GetMsg (M_AboutK);
                        SysTrayMen_Setup.Caption := GetMsg (M_SetupK);
                        SysTrayMen_CallerList.Caption := GetMsg (M_CallerListK);
                        SysTrayMen_ConnectionList.Caption := GetMsg (M_ConnectListK);
                        SysTrayMen_Dialmode.Caption := GetMsg (M_DialmodeK);
                        SysTrayMen_Numbers.Caption := GetMsg (M_NumbersK);
                        SysTrayMen_AddLink.Caption := GetMsg (M_AddLinkK);
                        SysTrayMen_RemoveLink.Caption := GetMsg (M_RemoveLinkK);

                        i4lMonitorb1.Caption := GetMsg (M_QuitK);

                        SysTrayMen_SelectLanguage.Caption := GetMsg (M_SelectLangK);
                         
                        // Refresh Interfaces for Dial/Hangup
                        {$IFNDEF DontReadInterfaceNames}
                        Isdn4Linux1.i4ld_GetInterfaces;
                        {$ENDIF}
                        IF Isdn4Linux1.InterfaceCount > 0 THEN
                        BEGIN
                        {$IFDEF AllowDialHangup}
                        // Add Interfaces to Popup (Dial)

                          SysTrayMen_Dial.Enabled := TRUE;
                          WHILE SysTrayMen_Dial.Count > 0 DO
                            SysTrayMen_Dial.Delete(0);
                          FOR I := 0 TO Isdn4Linux1.InterfaceCount-1 DO
                          BEGIN
                            T := TMenuItem.Create (i4lMonitorb1);
                            T.OnClick := SysTrayMen_DialClick;
                            T.Caption := Isdn4Linux1.InterfaceNames[I];
                            Numbers := Isdn4Linux1.InterfaceOutNumbers [I];
                            IF Numbers = '' THEN
                              T.Enabled := FALSE
                            ELSE
                              T.Caption := T.Caption + ' ('+Isdn4Linux1.Phonebook [Numbers]+')';
                            Status := Isdn4Linux1.i4ld_GetInterfaceConnectionStatus (Ifname);
                            IF Status >= IFSConnectedInK THEN
                              T.Enabled := FALSE;
                            SysTrayMen_Dial.Add (T);
                          END;

                          // add Interfaces to Hangup-Menu
                          WHILE SysTrayMen_Hangup.Count > 0 DO
                            SysTrayMen_Hangup.Delete(0);
                          FOR I := 0 TO Isdn4Linux1.InterfaceCount-1 DO
                          BEGIN
                            SysTrayMen_Hangup.Enabled := TRUE;
                            T := TMenuItem.Create (i4lMonitorb1);
                            T.OnClick := SysTrayMen_HangupClick;
                            Numbers := Isdn4Linux1.InterfaceOutNumbers [I];
                            IF Numbers = '' THEN
                              Numbers := Isdn4Linux1.InterfaceInNumbers [I];
                            Ifname := Isdn4Linux1.InterfaceNames[I];
                            T.Caption := Ifname;
                            IF Numbers <> '' THEN
                              T.Caption := T.Caption + ' ('+Isdn4Linux1.Phonebook [Numbers]+')';
                            Status := Isdn4Linux1.i4ld_GetInterfaceConnectionStatus (Ifname);
                            IF Status = IFSNotConnectedK THEN
                              T.Enabled := FALSE;
                            SysTrayMen_Hangup.Add (T);
                          END;
                        {$ENDIF}
                        {$IFDEF AllowInterfaceInfo}
                          // add Interfaces to Info-Menu
                          WHILE SysTrayMen_Info.Count > 0 DO
                            SysTrayMen_Info.Delete(0);
                          FOR I := 0 TO Isdn4Linux1.InterfaceCount-1 DO
                          BEGIN
                            SysTrayMen_Info.Enabled := TRUE;
                            T := TMenuItem.Create (i4lMonitorb1);
                            T.OnClick := SysTrayMen_InfoClick;
                            Numbers := Isdn4Linux1.InterfaceOutNumbers [I];
                            IF Numbers = '' THEN
                              Numbers := Isdn4Linux1.InterfaceInNumbers [I];
                            T.Caption := Isdn4Linux1.InterfaceNames[I];
                            IF Numbers <> '' THEN
                              T.Caption := T.Caption + ' ('+Isdn4Linux1.Phonebook [Numbers]+')';
                            SysTrayMen_Info.Add (T);
                          END;
                        {$ENDIF}

                        {$IFDEF AllowDialmode}
                          // add outgoing Interfaces to Dialmode-Menu
                          hasDialmode := FALSE;
                          SysTrayMen_Dialmode.Enabled := TRUE;
                          WHILE SysTrayMen_Dialmode.Count > 0 DO
                            SysTrayMen_Dialmode.Delete(0);
                          FOR I := 0 TO Isdn4Linux1.InterfaceCount-1 DO
                          BEGIN
                            Numbers := Isdn4Linux1.InterfaceOutNumbers [I];
                            IF Numbers <> '' THEN
                            BEGIN
                              Dialmode := Isdn4Linux1.InterfaceDialmode [I];
                              IF Copy (Dialmode,1,6) <> '!ERROR' THEN
                              BEGIN
                                hasDialmode := TRUE;
                                T := TMenuItem.Create (i4lMonitorb1);
                                T.Caption := Isdn4Linux1.InterfaceNames[I] + ' ('+Isdn4Linux1.Phonebook [Numbers]+')';
                                SysTrayMen_Dialmode.Add (T);


                                T1 := TMenuItem.Create (T);
                                T1.Caption := 'off';
                                IF Dialmode = 'off' THEN T1.Checked := TRUE;
                                T1.OnClick := SysTrayMen_DialmodeClick;
                                T.Add (T1);

                                T1 := TMenuItem.Create (T);
                                T1.Caption := 'manual';
                                IF Dialmode = 'manual' THEN T1.Checked := TRUE;
                                T1.OnClick := SysTrayMen_DialmodeClick;
                                T.Add (T1);

                                T1 := TMenuItem.Create (T);
                                T1.Caption := 'auto';
                                IF Dialmode = 'auto' THEN T1.Checked := TRUE;
                                T1.OnClick := SysTrayMen_DialmodeClick;
                                T.Add (T1);
                              END;
                            END;
                          END;
                          SysTrayMen_Dialmode.Enabled := hasDialmode;
                        {$ENDIF}
                        END ELSE
                        BEGIN
                          SysTrayMen_Hangup.Enabled := FALSE;
                          SysTrayMen_Dial.Enabled := FALSE;
                          SysTrayMen_Info.Enabled := FALSE;
                          SysTrayMen_Dialmode.Enabled := FALSE;
                        END;

                        // Add Interfaces with Channel-Bundling to
                        // addChannel and RemoveChannel
                        {$IFDEF AllowAdDropChannel}
                        IF Isdn4Linux1.CBInterfaceCount > 0 THEN
                        BEGIN
                          SysTrayMen_AddLink.Enabled := TRUE;
                          WHILE SysTrayMen_AddLink.Count > 0 DO
                            SysTrayMen_AddLink.Delete(0);
                          FOR I := 0 TO Isdn4Linux1.CBInterfaceCount-1 DO
                          BEGIN
                            T := TMenuItem.Create (i4lMonitorb1);
                            T.OnClick := SysTrayMen_AddLinkClick;
                            T.Caption := Isdn4Linux1.CBInterfaceNames[I];
                            J := Isdn4Linux1.GetInterfaceNumber (T.Caption);
                            IF J > -1 THEN
                            BEGIN
                              Numbers := Isdn4Linux1.InterfaceOutNumbers [I];
                              IF Numbers <> '' THEN
                                T.Caption := T.Caption + ' ('+Isdn4Linux1.Phonebook [Numbers]+')';
                            END;
                            SysTrayMen_AddLink.Add (T);
                          END;

                          SysTrayMen_RemoveLink.Enabled := TRUE;
                          WHILE SysTrayMen_RemoveLink.Count > 0 DO
                            SysTrayMen_RemoveLink.Delete(0);
                          FOR I := 0 TO Isdn4Linux1.CBInterfaceCount-1 DO
                          BEGIN
                            T := TMenuItem.Create (i4lMonitorb1);
                            T.OnClick := SysTrayMen_RemoveLinkClick;
                            T.Caption := Isdn4Linux1.CBInterfaceNames[I];
                            J := Isdn4Linux1.GetInterfaceNumber (T.Caption);
                            IF J > -1 THEN
                            BEGIN
                              Numbers := Isdn4Linux1.InterfaceOutNumbers [I];
                              IF Numbers <> '' THEN
                                T.Caption := T.Caption + ' ('+Isdn4Linux1.Phonebook [Numbers]+')';
                            END;
                            SysTrayMen_RemoveLink.Add (T);
                          END;
                        END ELSE
                        BEGIN
                          SysTrayMen_AddLink.Enabled := FALSE;
                          SysTrayMen_RemoveLink.Enabled := FALSE;
                        END;
                        {$ENDIF}

                        {$IFDEF AllowCallerList}
                        SysTrayMen_CallerList.Enabled := (AnruferlisteForm.StringGrid1.RowCount > 1);
                        {$ENDIF}

                        {$IFDEF AllowConnectionList}
                        SysTrayMen_ConnectionList.Enabled := (ConnectionListForm.StringGrid1.RowCount > 1);
                        {$ENDIF}

                        SetForegroundWindow(Handle);
                        SysTrayMenu.Popup(Posi.X, Posi.Y);
                        // ohne diese Message verschwindet das Popup manchmal
                        // nicht wenn ein anderes Fenster den Focus bekommt
                        PostMessage(Handle, WM_NULL, 0, 0);
                      END;
    // Test Reconnect:
    //WM_LBUTTONDOWN  : CloseSocket (Isdn4Linux1.IsdnInfoThread.SockHandle);
    WM_LBUTTONDBLCLK: IF Visible THEN
                        SysTrayMen_HideClick(SELF)
                      ELSE
                        SysTrayMen_ShowClick(SELF);
  END;
END;


PROCEDURE TMainForm.LangChangedMsg (VAR Msg : TMessage);
BEGIN
  WITH StringGrid1 DO
  BEGIN
    Cells [0,0] := GetMsg (M_NrK);
    Cells [1,0] := GetMsg (M_LineIdK);
    Cells [2,0] := GetMsg (M_StatusK);
    Cells [3,0] := GetMsg (M_TelefonnummerK);
    Cells [4,0] := GetMsg (M_DienstK);
    Cells [5,0] := GetMsg (M_TypK);
  END;
  {$IFDEF AllowChangeNumbers}
  IF NummernForm <> NIL THEN PostMessage(NummernForm.Handle,LangChangedMsgK,0,0);
  {$ENDIF}
  IF SetupFrm <> NIL THEN PostMessage(SetupFrm.Handle,LangChangedMsgK,0,0);
  IF IpppInfoForm <> NIL THEN PostMessage(IpppInfoForm.Handle,LangChangedMsgK,0,0);
  {$IFDEF AllowCallerList}
  IF AnruferlisteForm <> NIL THEN PostMessage(AnruferlisteForm.Handle,LangChangedMsgK,0,0);
  {$ENDIF}
  {$IFDEF AllowConnectionList}
  IF ConnectionListForm <> NIL THEN PostMessage(ConnectionListForm.Handle,LangChangedMsgK,0,0);
  {$ENDIF}
  Isdn4Linux1.SetErrorText (GetMsg (M_CO_UnabConnK));
END;


PROCEDURE TMainForm.NewHotkey (Ena : BOOLEAN;
                            Hot : CHAR);
BEGIN
  IF HotkeyRegistred THEN
  BEGIN
    UnregisterHotKey (HANDLE, 1);
    HotkeyRegistred := FALSE;
  END;
  IF Ena THEN
    HotkeyRegistred :=
      RegisterHotKey (HANDLE,
                      1,                    // identifier of hot key
                      MOD_ALT+MOD_CONTROL,  // key-modifier flags
                      BYTE(Hot));
  HotkeyEnabled := Ena;
  Hotkey := Hot;
END;


PROCEDURE TMainForm.FormCreate(Sender: TObject);
BEGIN
  FillChar (ActiveTaskBarIcons, SIZEOF (ActiveTaskBarIcons), $FF);


  IconHintText := 'Isdn4Linux Monitor';

  TaskBarIcons [0] := LoadIcon (HINSTANCE, 'ISDN0');
  TaskBarIcons [1] := LoadIcon (HINSTANCE, 'ISDN1');
  TaskBarIcons [2] := LoadIcon (HINSTANCE, 'ISDN2');
  TaskBarIcons [3] := LoadIcon (HINSTANCE, 'ISDN3');
  TaskBarIcons [4] := LoadIcon (HINSTANCE, 'ISDN4');
  TaskBarIcons [5] := LoadIcon (HINSTANCE, 'ISDN5');
  TaskBarIcons [6] := LoadIcon (HINSTANCE, 'ISDN6');
  TaskBarIcons [7] := LoadIcon (HINSTANCE, 'ISDN7');
  TaskBarIcons [8] := LoadIcon (HINSTANCE, 'ISDN8');
  TaskBarIcons [9] := LoadIcon (HINSTANCE, 'ISDN9');

  WITH StringGrid1 DO
  BEGIN
    IF RowCount < 1 THEN
      RowCount := 1;
  END;
  RestoreWindowPos;
  {$IFNDEF AllowDialHangup}
  SysTrayMen_Dial.Visible := FALSE;
  SysTrayMen_Hangup.Visible := FALSE;
  {$ENDIF}

  {$IFNDEF AllowCallerList}
  SysTrayMen_CallerList.Visible := FALSE;
  {$ENDIF}

  {$IFNDEF AllowConnectionList}
  SysTrayMen_ConnectionList.Visible := FALSE;
  {$ENDIF}

  {$IFNDEF AllowDialmode}
  SysTrayMen_Dialmode.Visible := FALSE;
  {$ENDIF}

  {$IFNDEF AllowChangeNumbers}
  SysTrayMen_Numbers.Visible := FALSE;
  {$ENDIF}

  {$IFNDEF AllowAdDropChannel}
  SysTrayMen_AddLink.Visible := FALSE;
  SysTrayMen_RemoveLink.Visible := FALSE;
  {$ENDIF}

  {$IFNDEF AllowInterfaceInfo}
  SysTrayMen_Info.Visible := FALSE;
  {$ENDIF}

  {$IFNDEF AllowDialHangup}
     {$IFNDEF AllowAdDropChannel}
       {$IFNDEF AllowInterfaceInfo}
         {$IFNDEF AllowDialmode}
           {$IFNDEF AllowChangeNumbers}
              N3.Visible := FALSE;
           {$ENDIF}
         {$ENDIF}
       {$ENDIF}
     {$ENDIF}
  {$ENDIF}

  NewHotkey (HotkeyEnabled, Hotkey);
  PostMessage(Handle,LangChangedMsgK,0,0);
END;


PROCEDURE TMainForm.OnHotkey (VAR Msg : TMessage);
VAR M1 : TMessage;
BEGIN
  M1 := Msg;
  M1.lParam := WM_RBUTTONDOWN;
  TBarMsg (M1);
END;


PROCEDURE TMainForm.ShowSysTrayIcon  (DriverNum : BYTE;
                                   IconType  : BYTE);
BEGIN
  IF ActiveTaskBarIcons [DriverNum] = IconType THEN EXIT;
  WITH TData DO
  BEGIN
    cbSize:= SIZEOF (TData);
    Wnd := Handle;
    uID:= DriverNum;
    uFlags:= NIF_ICON + NIF_TIP + NIF_MESSAGE;
    uCallbackMessage:= SysTrayMsgK;
    IF IconType <> $FF THEN
      hIcon:= TaskBarIcons [IconType];
    StrPCopy (szTip, IconHintText);
    IF IconType = $FF THEN
      Shell_NotifyIcon(NIM_DELETE,@TData)
    ELSE
      IF ActiveTaskBarIcons [DriverNum] = $FF THEN
        Shell_NotifyIcon(NIM_ADD,@TData)
      ELSE
        Shell_NotifyIcon(NIM_MODIFY,@TData);
    ActiveTaskBarIcons [DriverNum] := IconType;
  END;
END;



PROCEDURE TMainForm.DisableSysTrayIcons;
VAR I : BYTE;
BEGIN
  FOR I := 0 TO I4LMaxCardsK-1 DO
    IF ActiveTaskBarIcons [I] <> $FF THEN
    WITH TData DO
    BEGIN
      cbSize:= SIZEOF (TData);
      Wnd := Handle;
      uID:= I;
      uFlags:= 0;
      uCallbackMessage:= SysTrayMsgK;
      IF Shell_NotifyIcon(NIM_DELETE,@TData) THEN
        ActiveTaskBarIcons [I] := $FF;
    END;
END;


procedure TMainForm.FormDestroy(Sender: TObject);
begin
  DisableSysTrayIcons;
  NewHotkey (FALSE,'I');
  Isdn4Linux1.i4ld_DisConnect;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  SaveWindowPos;
  IF NOT TerminateAllowed THEN
  BEGIN
    CanClose := FALSE;
    Hide;
  END;
end;


// !! Delphi schliet das Fenster bei nderung von FormStyle, daher
//    wird alles beendet und neu gestartet
procedure TMainForm.SysTrayMen_AlwaysOnTopClick(Sender: TObject);
VAR OldIcons : IconNumsT;
    I        : INTEGER;
begin
  OldIcons := ActiveTaskBarIcons;
  DisableSysTrayIcons;

  IF FormStyle = fsStayOnTop THEN
    FormStyle := fsNormal
  ELSE
    FormStyle := fsStayOnTop;
  SysTrayMen_AlwaysOnTop.Checked := (FormStyle = fsStayOnTop);

  FOR I := LOW (OldIcons) TO High (OldIcons) DO
    IF OldIcons[I] <> $FF THEN
      ShowSysTrayIcon  (I,OldIcons[I]);
end;

procedure TMainForm.SysTrayMen_ShowClick(Sender: TObject);
begin
  Show;
end;

procedure TMainForm.SysTrayMen_HideClick(Sender: TObject);
begin
  Hide;
end;

procedure TMainForm.i4lMonitorb1Click(Sender: TObject);
begin
  TerminateAllowed := TRUE;
  Close;
end;


PROCEDURE KillAnd (VAR S : STRING);
VAR P : INTEGER;
BEGIN
  P := Pos ('&', S);
  WHILE P > 0 DO
  BEGIN
    Delete (S,P,1);
    P := Pos ('&', S);
  END;
END;



FUNCTION  TMainForm.GetIpppNameFormMenu (T : TMenuItem) : STRING;
VAR I : INTEGER;
BEGIN
  Result := Trim (T.Caption);
  I := Pos (' ', Result);
  IF I = 0 THEN I := Pos ('(', Result);
  IF I > 0 THEN
    Result := Copy (Result,1,I-1);
  KillAnd (Result);
END;

// Menu Dial/Hangup
PROCEDURE TMainForm.SysTrayMen_DialClick (Sender: TObject);
{$IFDEF AllowDialHangup}
VAR IfName : STRING;
{$ENDIF}
BEGIN
  {$IFDEF AllowDialHangup}
  IF Sender IS TMenuItem THEN
  BEGIN
    IfName := GetIpppNameFormMenu (TMenuItem(Sender));
    TRY
      TRY
        Isdn4Linux1.Dial (IfName);
      EXCEPT
        Isdn4Linux1.i4ld_Connect;
        Isdn4Linux1.Dial (IfName);
      END;
    EXCEPT
      IfName := Format (GetMsg (M_DialErrorK),[Isdn4Linux.LastLinuxResponse]);
      Application.MessageBox (PChar(Ifname),PChar(GetMsg (M_ProblemK)),MB_OK + MB_ICONSTOP);
    END;
  END;
  {$ENDIF}
END;

PROCEDURE TMainForm.SysTrayMen_AddLinkClick (Sender: TObject);
{$IFDEF AllowAdDropChannel}
VAR IfName : STRING;
    ErrMsg : STRING;
{$ENDIF}
BEGIN
  {$IFDEF AllowAdDropChannel}
  IF Sender IS TMenuItem THEN
  BEGIN
    ErrMsg := GetMsg (M_AddLinkErrorK);
    IfName := GetIpppNameFormMenu (TMenuItem(Sender));
    TRY
      TRY
        ErrMsg := Isdn4Linux1.i4ld_AddLink (IfName);
      EXCEPT
        Isdn4Linux1.i4ld_Connect;  // Reconnect to i4lmond
        ErrMsg := Isdn4Linux1.i4ld_AddLink (IfName);
      END;
    EXCEPT
      Application.MessageBox (PChar(ErrMsg),PChar(GetMsg (M_ProblemK)),MB_OK + MB_ICONSTOP);
    END;
  END;
  IF Copy (ErrMsg,1,6) = '!ERROR' THEN
  BEGIN
    Delete (ErrMsg,1,1);
    ErrMsg := Format (GetMsg (M_AddLinkError2K),[ErrMsg]);
    Application.MessageBox (PChar(ErrMsg),PChar(GetMsg (M_ProblemK)),MB_OK + MB_ICONSTOP);
  END;
  {$ENDIF}
END;

PROCEDURE TMainForm.SysTrayMen_RemoveLinkClick (Sender: TObject);
{$IFDEF AllowAdDropChannel}
VAR IfName : STRING;
    ErrMsg : STRING;
{$ENDIF}
BEGIN
  {$IFDEF AllowAdDropChannel}
  IF Sender IS TMenuItem THEN
  BEGIN
    ErrMsg := GetMsg (M_RemLinkErrorK);
    IfName := GetIpppNameFormMenu (TMenuItem(Sender));
    TRY
      TRY
        ErrMsg := Isdn4Linux1.i4ld_RemoveLink (IfName);
      EXCEPT
        Isdn4Linux1.i4ld_Connect;  // Reconnect to i4lmond
        ErrMsg := Isdn4Linux1.i4ld_RemoveLink (IfName);
      END;
    EXCEPT
      Application.MessageBox (PChar(ErrMsg),PChar (GetMsg (M_ProblemK)),MB_OK + MB_ICONSTOP);
    END;
  END;
  IF Copy (ErrMsg,1,6) = '!ERROR' THEN
  BEGIN
    Delete (ErrMsg,1,1);
    ErrMsg := Format (GetMsg (M_RemLinkError2K), [ErrMsg]);
    Application.MessageBox (PChar(ErrMsg),PChar (GetMsg (M_ProblemK)),MB_OK + MB_ICONSTOP);
  END;
  {$ENDIF}
END;




// Menu Dialmode
PROCEDURE TMainForm.SysTrayMen_DialmodeClick (Sender: TObject);
{$IFDEF AllowDialmode}
VAR IfName   : STRING;
    Dialmode : STRING;
    Resu     : STRING;
{$ENDIF}
BEGIN
  {$IFDEF AllowDialmode}
  IF Sender IS TMenuItem THEN
  BEGIN
    IfName := GetIpppNameFormMenu (TMenuItem(Sender).Parent);
    Dialmode := TMenuItem(Sender).Caption;
    KillAnd (Dialmode);  // & entfernen
    Resu := Isdn4Linux1.i4ld_SetDialmode (IfName, Dialmode);
    IF Copy (Resu,1,6) = '!ERROR' THEN
    BEGIN
      Resu := Format (GetMsg (M_ErrSetDialmodeK),[Resu]);
      Application.MessageBox (
          PChar (Resu),
          PChar (GetMsg (M_ProblemK)), MB_Ok + MB_IconExclamation);
    END;
  END;
  {$ENDIF}
END;


PROCEDURE TMainForm.SysTrayMen_HangupClick (Sender: TObject);
{$IFDEF AllowDialHangup}
VAR IfName : STRING;
{$ENDIF}
BEGIN
  {$IFDEF AllowDialHangup}
  IF Sender IS TMenuItem THEN
  BEGIN
    IfName := GetIpppNameFormMenu (TMenuItem(Sender));
    TRY
      TRY
        Isdn4Linux1.Hangup (IfName);
      EXCEPT
        Isdn4Linux1.i4ld_Connect;
        Isdn4Linux1.Hangup (IfName);
      END;
    EXCEPT
      Application.MessageBox (PChar (GetMsg (M_ErrHangupK)),PChar (GetMsg (M_ProblemK)),MB_OK + MB_ICONSTOP);
    END;
  END;
  {$ENDIF}
END;


PROCEDURE TMainForm.SysTrayMen_InfoClick (Sender: TObject);
{$IFDEF AllowInterfaceInfo}
VAR Ok : BOOLEAN;
    IfName : STRING;
{$ENDIF}
BEGIN
  {$IFDEF AllowInterfaceInfo}
  IF Sender IS TMenuItem THEN
  BEGIN
    IF IpppInfoForm = NIL THEN
      IpppInfoForm := TIpppInfoForm.Create (SELF);
    IfName := GetIpppNameFormMenu (TMenuItem(Sender));
    Ok := Isdn4Linux1.i4ld_ListIf (IfName,
                                   IpppInfoForm.StringGrid1);
    IF Ok THEN
    BEGIN
      IpppInfoForm.Caption := GetMsg (M_II_CaptionK)+ ' '+IfName;
      IpppInfoForm.Show;
    END ELSE
      Application.MessageBox (PChar (GetMsg (M_ErrListK)),PChar (GetMsg (M_ProblemK)),MB_OK + MB_ICONSTOP);
  END;
  {$ENDIF}
END;


procedure TMainForm.SysTrayMen_AboutClick(Sender: TObject);
begin
  IF AboutForm = NIL THEN
    AboutForm := TAboutForm.Create (SELF);
  AboutForm.VersionLabel.Caption := VersionK;
  AboutForm.i4mondVersionLabel.Caption := Isdn4Linux1.i4ldVersion;
  AboutForm.Show;
end;



procedure TMainForm.Isdn4Linux1BChannelChange(Sender: TObject;
  DriverLoaded: Boolean; DriverNum, B1, B2: Byte);
VAR IconTypeNum : BYTE;
BEGIN
  IF NOT DriverLoaded THEN
  BEGIN
    IF DriverNum = 0 THEN
      IconTypeNum := 9
    ELSE
      IconTypeNum := $FF;
  END ELSE
    IconTypeNum := B1 + (B2 * 3);

  ShowSysTrayIcon  (DriverNum, IconTypeNum);
END;



PROCEDURE TMainForm.Isdn4Linux1StatusChange (    Sender    : TObject;
                                          VAR NewStatus,
                                              OldStatus : TIsdnStatus);
VAR I : INTEGER;
    S : STRING;
begin
  WITH StringGrid1 DO
  BEGIN
    I := NewStatus.Index;
    INC (I);
    IF RowCount < I+1 THEN
      RowCount := I+1;
    Cells [0,I] := IntToStr (NewStatus.Index);
    Cells [1,I] := NewStatus.IdString;
    IF NewStatus.Service = IS_NoneK THEN
      Cells [2,I] := GetMsg (M_InactiveK)
    ELSE
    IF NewStatus.BChannelActive THEN
      Cells [2,I] := GetMsg (M_ActiveK)
    ELSE
    IF NewStatus.Outgoing THEN
      Cells [2,I] := GetMsg (M_StatusDialK)
    ELSE
      Cells [2,I] := GetMsg (M_StatusRingK);

    IF newStatus.PhonebookName <> '' THEN
      Cells [3,I] := newStatus.PhonebookName
    ELSE
      Cells [3,I] := newStatus.PhoneNumber;

    S := '';
    IF newStatus.Service <> IS_NoneK THEN
      S := ServiceTxtK [newStatus.Service];
    Cells [4,I] := S;

    IF newStatus.Service = IS_NoneK THEN
      Cells[5,I] := ''
    ELSE  
    IF newStatus.Outgoing THEN
      Cells[5,I] := GetMsg (M_StatusOutK)
    ELSE
      Cells[5,I] := GetMsg (M_StatusInK)
  END;
END;

procedure TMainForm.Isdn4Linux1LinuxDisconnect(Sender: TObject);
begin
  Caption := Isdn4Linux1.LinuxAddrOrName + ' - ' + GetMsg (M_NotConnK);
  Isdn4Linux1BChannelChange(SELF,FALSE,0,0,0);
end;


VAR IsdnInfoThreadEventActive : BOOLEAN = FALSE;

procedure TMainForm.Isdn4Linux1LinuxConnect(Sender: TObject);
begin
  Caption := Isdn4Linux1.LinuxAddrOrName;
  //Isdn4Linux1BChannelChange(SELF,TRUE,0,0,0);
  {IF NOT IsdnInfoThreadEventActive THEN  // to redraw icon after reconnect
  BEGIN
    IsdnInfoThreadEventActive := TRUE;
    Isdn4Linux1.IsdnInfoThreadEvent (TreadEvent_StatusChangeAllK);
    IsdnInfoThreadEventActive := FALSE;
  END;}
end;

procedure TMainForm.StringGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
VAR M : TMessage;
begin
  IF Button = mbRight THEN
  BEGIN
    M.lParam := WM_RBUTTONDOWN;
    TBarMsg (M);
  END;
end;

procedure TMainForm.SysTrayMen_SetupClick(Sender: TObject);
begin
  TRY
    SysTrayMen_Setup.Enabled := FALSE;
    SetupFrm := TSetupFrm.Create (SELF);
    SetupFrm.LinuxAddrEdit.Text := LinuxAddrOrName;
    SetupFrm.LinuxPortEdit.Text := IntToStr (Isdn4Linux1.LinuxPort);
    {$IFDEF AllowCallerList}
    SetupFrm.IncomingCallVoicePopup.Checked := ShowIncomingCalls[IS_VoiceK];
    SetupFrm.IncomingCallModemPopup.Checked := ShowIncomingCalls[IS_ModemK];
    SetupFrm.IncomingCallRawPopup.Checked := ShowIncomingCalls[IS_RawK];
    SetupFrm.IncomingCallNetPopup.Checked := ShowIncomingCalls[IS_NetK];
    SetupFrm.CallerList.Checked := ShowCallerList;
    SetupFrm.CallerListAutoShow.Checked := CallerListAutoShow;
    {$ENDIF}

    {$IFDEF AllowConnectionList}
    SetupFrm.ShowConnOutVoice.Checked := ShowConnectionsOut [IS_VoiceK];
    SetupFrm.ShowConnOutModem.Checked := ShowConnectionsOut [IS_ModemK];
    SetupFrm.ShowConnOutRaw.Checked := ShowConnectionsOut [IS_RawK];
    SetupFrm.ShowConnOutNet.Checked := ShowConnectionsOut [IS_NetK];
    SetupFrm.ShowConnInVoice.Checked := ShowConnectionsIn [IS_VoiceK];
    SetupFrm.ShowConnInModem.Checked := ShowConnectionsIn [IS_ModemK];
    SetupFrm.ShowConnInRaw.Checked := ShowConnectionsIn [IS_RawK];
    SetupFrm.ShowConnInNet.Checked := ShowConnectionsIn [IS_NetK];
    SetupFrm.IncomingCallShowTimeEdit.Value := IncomingCallShowTime;
    SetupFrm.FontSizeEdit.Value := IncomingCall.FontSize;
    SetupFrm.FontNameEdit.Text := IncomingCall.FontName;
    SetupFrm.FontStyle := IncomingCall.FontStyle;

    {$ENDIF}
    SetupFrm.HotkeyEnable.Checked := HotkeyEnabled;
    IF (Hotkey < 'A') OR (Hotkey > 'Z') THEN Hotkey := 'I';
    SetupFrm.HotKeyBox.ItemIndex := BYTE(Hotkey) - BYTE ('A');
    SetupFrm.ShowModal;
  FINALLY
    SysTrayMen_Setup.Enabled := TRUE;
    SetupFrm.Free;
    SetupFrm := NIL;
  END;
end;

procedure TMainForm.Isdn4Linux1Ring(Sender: TObject;
  var NewStatus: TIsdnStatus);
{$IFDEF AllowCallerList} {$IFNDEF ShowCallsFromMessages}
VAR W : HWND;
{$ENDIF} {$ENDIF}
begin
  {$IFDEF AllowCallerList}
  {$IFNDEF ShowCallsFromMessages}
  IF ShowIncomingCalls[NewStatus.Service] THEN
  BEGIN
    IncomingCallForm.AnrufVonLabel.Caption := NewStatus.PhoneNumber;
    IncomingCallForm.AnrufNameLabel.Caption := NewStatus.PhonebookName;
    W := GetActiveWindow;
    IncomingCallForm.Show;
    SetActiveWindow (W);
  END;
  {$ENDIF}
  {$ENDIF}
end;

procedure TMainForm.Isdn4Linux1Connect(Sender: TObject;
  var NewStatus: TIsdnStatus);
begin
  {$IFDEF AllowCallerList}
  {$IFNDEF ShowCallsFromMessages}
  IF ShowIncomingCalls[NewStatus.Service] THEN
    IncomingCallForm.Hide;
  {$ENDIF}
  {$ENDIF}
end;

procedure TMainForm.Isdn4Linux1Terminate(Sender: TObject; var NewStatus,
  OldStatus: TIsdnStatus);
begin
  {$IFDEF AllowCallerList}
  IF ShowIncomingCalls[OldStatus.Service] THEN
    IncomingCallForm.Hide;

  IF ShowCallerList THEN                   // Caller-List only for
    IF OldStatus.Service = IS_VoiceK THEN  // Voice Calls
    BEGIN
      AnruferlisteForm.Add (OldStatus.PhoneNumber, OldStatus.PhonebookName);
      IF CallerListAutoShow THEN
        AnruferlisteForm.Show;
    END;
  {$ENDIF}
end;

procedure TMainForm.SysTrayMen_CallerListClick(Sender: TObject);
begin
  AnruferlisteForm.Show;
end;

procedure TMainForm.Isdn4Linux1Disconnect(Sender: TObject; var NewStatus,
  OldStatus: TIsdnStatus);
BEGIN
  {$IFDEF AllowConnectionList}
  IF OldStatus.Outgoing THEN
  BEGIN
    IF ShowConnectionsOut [OldStatus.Service] THEN
      ConnectionListForm.Add (OldStatus);
  END ELSE
    IF ShowConnectionsIn [OldStatus.Service] THEN
      ConnectionListForm.Add (OldStatus);
  {$ENDIF}
END;

procedure TMainForm.SysTrayMen_ConnectionListClick(Sender: TObject);
begin
  {$IFDEF AllowConnectionList}
  ConnectionListForm.Show;
  {$ENDIF}
end;

procedure TMainForm.SysTrayMen_NumbersClick(Sender: TObject);
{$IFDEF AllowChangeNumbers}
begin
  TRY
    NummernForm := TNummernForm.Create (SELF);
    NummernForm.Init (Isdn4Linux1);
    NummernForm.Show;
  FINALLY
  END;
{$ELSE}
BEGIN
{$ENDIF}
end;

procedure TMainForm.IncomingCallCloseTimerTimer(Sender: TObject);
begin
  {$IFDEF AllowCallerList}
  {$IFDEF ShowCallsFromMessages}
  IncomingCallCloseTimer.Enabled := FALSE;
  IncomingCallForm.Hide;
  IF ShowCallerList THEN                   // Caller-List only for
    IF LastUBService = IS_VoiceK THEN      // Voice Calls
    BEGIN
      // AnruferlisteForm.Add (LastUBCallFrom, LastUBCallFromName);
      IF CallerListAutoShow THEN
        AnruferlisteForm.Show;
    END;
  LastUBCallFromName := '';
  LastUBCallFrom := '';
  LastUBCallTo := '';
  {$ENDIF}
  {$ENDIF}
end;

procedure TMainForm.Isdn4Linux1UnboundCall(Sender: TObject; CallFrom,
  CallTo: String; Service: Ti4lService);
{$IFDEF AllowCallerList} {$IFDEF ShowCallsFromMessages}
VAR W : HWND;
{$ENDIF} {$ENDIF}
begin
  {$IFDEF AllowCallerList}
  {$IFDEF ShowCallsFromMessages}

  IF (ShowIncomingCalls[Service]) OR (ShowCallerList) THEN
  BEGIN
    LastUBCallFromName := Isdn4Linux1.GetPhonebookEntry (CallFrom);
    LastUBCallFrom := CallFrom;
    LastUBCallTo   := CallTo;
    LastUBService  := Service;
  END;

  IF ShowIncomingCalls[Service] THEN
  BEGIN
    IncomingCallForm.AnrufVonLabel.Caption := CallFrom + ' ' + GetMsg (M_ToK)+' '+CallTo;
    IncomingCallForm.AnrufNameLabel.Caption := LastUBCallFromName;
    W := GetActiveWindow;
    IncomingCallForm.Show;
    IncomingCallCloseTimer.Enabled := FALSE;
    IncomingCallCloseTimer.Interval := IncomingCallShowTime * 1000;
    IncomingCallCloseTimer.Enabled := TRUE;
    SetActiveWindow (W);
  END;

  IF ShowCallerList THEN                   // Caller-List only for
    IF LastUBService = IS_VoiceK THEN      // Voice Calls
      AnruferlisteForm.Add (LastUBCallFrom, LastUBCallFromName);
  {$ENDIF}
  {$ENDIF}
end;

procedure TMainForm.SysTrayMen_SelectLanguageClick(Sender: TObject);
VAR S,Old : STRING;
begin
  TRY
    SysTrayMen_SelectLanguage.Enabled := FALSE;
    TRY
      Old := Lang.CurrLang;
      S := SelectLang;
      IF S <> '' THEN
      BEGIN
        Lang.SetLang (S);
        SaveLanguage;
      END;  
    EXCEPT
      Lang.SetLang (Old);
      PostMessage(Handle,LangChangedMsgK,0,0);
    END;
  FINALLY
    SysTrayMen_SelectLanguage.Enabled := TRUE;
  END;
end;

end.
